#include <stdio.h>
#include <string.h>
#include <ctype.h>

int c_ulohy = 0, p_uloh;

char a[1024], b[1024], *s, c;

char *dashes(int dash)
{
  char *res;
  int i;
  res=malloc(dash+3);
  for (i=0; i<dash; i++)
    res[i] = '-';
  res[dash] = 0;
  return res;
}

int maxlen(char *s, char *t)
{
  int i, j;
  i = strlen(s);
  j = strlen(t);
  if (i>j)
    return i;
  else return j;
}
#define MAX(a, b) (a>b?a:b)

char *
plus(char *s1, char *s2)
{
  int xfer = 0;
  char bufx[10240];
  int il, jl, i, len, sl;
  il = strlen(s1);
  jl = strlen(s2);
  len = MAX(il, jl);
  if (il<jl) {
    char *sx;
    sx = s2; s2 = s1; s1 = sx;
  }
  sl = strlen(s2);
  for (i=0; i<len; i++) {
    if (i>=sl)
      bufx[i] = s1[i] + xfer;
    else 
      bufx[i] = s1[i] + s2[i] - '0' + xfer;
    xfer = 0;
    if (bufx[i]>'9')
      bufx[i] -= 10, xfer = 1;
  }
  if (xfer)
    bufx[i++] = '1';
  bufx[i++] = 0;
  return strdup(bufx);
}

char *
minus(char *s1, char *s2)
{
  int xfer = 0;
  char bufx[10240];
  int il, jl, i, len, sl;
  il = strlen(s1);
  jl = strlen(s2);
  len = MAX(il, jl);
  sl = jl;
  for (i=0; i<len; i++) {
    if (i>=sl)
      bufx[i] = s1[i] - xfer;
    else 
      bufx[i] = s1[i] - s2[i] + '0' - xfer;
    xfer = 0;
    if (bufx[i]<'0')
      bufx[i] += 10, xfer = 1;
  }
  bufx[i++] = 0;
  return strdup(bufx);
}

char *output[2048];
int no;
char *result;

void krat(char *s1, char *s2)
{
  char buf[10240];
  int i;

  result = strdup("0");
  for (i=0; i<strlen(s2); i++) {
    int cif = s2[i] - '0';
    int j;
    int xfer = 0;
    int k = 0;

    for (j=0; j<i; j++)
      buf[k++] = '0';

    for (j=0; j<strlen(s1); j++) {
      int res = (s1[j] - '0')*cif + xfer;
      buf[k++] = res % 10 + '0';
      xfer = res/10;
    }
    if (xfer)
      buf[k++] = xfer + '0';
    buf[k++] = 0;

    result = plus(result, buf);
    for (j=0; j<i; j++)
      buf[j] = ' ';

    output[no++] = strdup(buf);
  }
  if (strlen(s2) != 1) {
    output[no++] = dashes(strlen(result));
    output[no++] = result;
  }
} 

void canonicalize(char *s)
{
  int l;
  int i;

  l = strlen(s);
  for (i=l-1; i>=1 && s[i] == '0'; i--)
    if ((s[i-1] >= '0') && (s[i-1] <= '9'))
      s[i] = 0;
}


void print(char *s, int pad)
{
  int l;
  int i;

  canonicalize(s);
  l = strlen(s);
  for (i=0; i<pad-l; i++)
    putchar(' ');
  for (i=l-1; i>=0; i--) {
    if (s[i]==' ')
      break;
    putchar(s[i]);
  }
  putchar('\n');
}

int main(void)
{
  scanf("%d\n", &p_uloh);
  for  (c_ulohy=0; c_ulohy < p_uloh; c_ulohy++) {
    int i,j,k;
    char buf[10240];
    gets(buf);
    /*    printf("got %s\n", buf);*/
    j = strlen(buf);
    s = b;
    for (i=j-1; i>=0; i--) {
      if (isdigit(buf[i]))
	*s++ = buf[i];
      else
	{ *s++ = 0; c = buf[i]; s = a; }
    }
    *s++ = 0;
    /*    printf("%s %c %s\n", a, c, b);*/
    for (i=0; i<2048; i++)
      output[i] = NULL;
    output[0]=strdup(a);
    output[1]=malloc(strlen(b)+5);
    strcpy(output[1],b);
    no = 3;
    switch(c) {
    case '+':
      output[3] = plus(output[0], output[1]); no++;
      strcat(output[1], "+");
      break;
    case '-':
      output[3] = minus(output[0], output[1]); no++;
      strcat(output[1], "-");
      break;
    case '*':
      krat(output[0], output[1]);
      strcat(output[1], "*");
      break;
    }
    canonicalize(output[3]);
    output[2]=dashes(MAX(strlen(output[3]), strlen(output[1])));


    {
      int i, maxlen = 0;
      for (i=0; i<no; i++) {
	int l = strlen(output[i]);
	if (l>maxlen)
	  maxlen=l;
      }

      for (i=0; i<no; i++)
	print(output[i], maxlen);
    }
    printf("\n");
  }
  return 0;
}
